image: docker:1.10.3
services:
  - docker:dind

stages:
  - test
  - release

variables:
  DOCKER_DRIVER: overlay

before_script:
  - export export TEST_IMAGE_NAME=registry.gitlab.com/$CI_PROJECT_PATH:${CI_COMMIT_REF_NAME/\//-}-$CI_COMMIT_SHA
  - export IMAGE_NAME=registry.gitlab.com/$CI_PROJECT_PATH:latest

build_image:
  stage: test
  script:
    - docker build -t $TEST_IMAGE_NAME .
    - docker login -e gitlab-ci@gitlab.com -u gitlab-ci-token -p $CI_JOB_TOKEN registry.gitlab.com
    - docker push $TEST_IMAGE_NAME

release_image:
  stage: release
  script:
    - docker login -e gitlab-ci@gitlab.com -u gitlab-ci-token -p $CI_JOB_TOKEN registry.gitlab.com
    - docker pull $TEST_IMAGE_NAME
    - docker tag $TEST_IMAGE_NAME $IMAGE_NAME
    - docker push $IMAGE_NAME
  only:
    - master
